SuperStrict
Framework brl.blitz
Import brl.max2d
Import brl.d3d7max2d
Import brl.Graphics
Import brl.timer
Import brl.random

SeedRnd MilliSecs()

'Const gw:Int=640, gh:Int=480, wmode:Int=1

Const gw:Int=800, gh:Int=600, wmode:Int=0
Const ASTEROID_STARTSIZE:Int=60, ASTEROID_ENDSIZE:Int=15
Const SHOT_STARTTICKS:Int=100
Const STARTLIFE:Int=200, MAXSHIELD:Int=2000, ENTRYSHIELD:Int=100
Const CETERI_VAL:Int=10

Global level:Int=0,lastbonus:Int=0

AppTitle="Asteroids"
Graphics gw,gh,wmode*32
SetBlend ALPHABLEND

Global ceteri:Int=0
Global timer:TTimer=CreateTimer(50)
Global player:TPlayer=New TPlayer

menu False
End

Function Main()
	Repeat
		Cls
		
		TParticle.CreateSome 1,gw/2,gh/2,Rand(1,10),1.01,1,50,$FFFFFF
		
		TShot.updateall
		player.update
		TAsteroid.updateall
		TParticle.updateall
		player.drawhud
		TBonus.updateall
				
		While ceteri And TAsteroid.list.count()<CETERI_VAL
			TAsteroid.CreateRand player.x,player.y
			ceteri:-1
		Wend
		
		If TAsteroid.list.isempty() Then nextlevel
		
		If KeyHit(KEY_ESCAPE) Then menu True
		If player.life<=0 Then Exit
		
		Flip 0
		WaitTimer timer
	Until AppTerminate()
	TParticle.createsome 100,player.x,player.y,10,0.86,2,60,$0000FF
	TParticle.createsome 50,player.x,player.y,10,0.92,1,40,$FF0000
	While TParticle.list.count(); TParticle.updateall; Flip 0; WaitTimer timer ; Wend
	SetAlpha 0.1
	For Local i:Int=1 To 50
		SetColor 0,0,0
		DrawRect 0,0,gw,gh
		Flip 0
		Delay 10
	Next
	Cls
	FlushKeys
	SetAlpha 1
EndFunction

Function bonustime:Float()
	Return 1.5*1.36^(level-lastbonus)*5000
EndFunction

Function nextlevel()
	Local i:Int
	If MilliSecs()-player.time<=bonustime() Then player.score:*2;lastbonus=level
	level:+1
	If level<CETERI_VAL Then
		For i=1 To level
			TAsteroid.CreateRand player.x,player.y
		Next
	Else
		For i=1 To CETERI_VAL
			TAsteroid.CreateRand player.x,player.y
		Next
		ceteri=level-CETERI_VAL
	EndIf
	player.time=MilliSecs()
EndFunction
	
Type TPlayer
	Field x:Float=gw/2, y:Float=gh/2, w:Float
	Field vel:Float, shottimer:Int
	Field life:Int, shots:Int, shotstime:Float, shieldticks:Int
	Field score:Int,time:Float
	Field inv_w:Int
	Method New()
		shots=1
		life=STARTLIFE
		shottimer=MilliSecs()
		shieldticks=ENTRYSHIELD
		shotstime=250
	EndMethod
	Method drawhud()
		Local a:Int,s:String, lf:Float
		SetColor 160,160,160
		DrawText "Level "+level,5,5
		DrawText "Punkte "+score,5,25
		DrawText "Zeit: ",gw-160,5
		s=String.FromFloat((MilliSecs()-time)/1000.0)
		DrawText s[..s.find(".")+3],gw-100,5
		SetColor 0,255,0
		s=String.FromFloat(bonustime()/1000.0)
		DrawText s[..s.find(".")+3],gw-100,25
		a=life/(STARTLIFE/100)
		SetColor 255,0,0
		DrawRect x-10,y-30,20,3
		SetColor 0,255,0
		lf=life
		If lf>STARTLIFE Then lf=STARTLIFE
		DrawRect x-10,y-30,20.0*Float(lf)/STARTLIFE,3
		SetColor 0,255,255
		DrawRect x-10,y-33,20.0*Float(shieldticks)/MAXSHIELD,3
	EndMethod
	Method shoot()
		Local a:Int,i:Int
		For i=0 Until shots
			TShot.Create x+Cos(w)*25,y+Sin(w)*15,w-2*(shots-1)*(shots-1)+4*(shots-1)*i
		Next
		shottimer=MilliSecs()
	EndMethod
	Method update()
		Local lf:Float
		If KeyDown(KEY_LEFT) Then
			w:-vel/3+1
		ElseIf KeyDown(KEY_RIGHT) Then
			w:+vel/3+1
		EndIf
		If KeyDown(KEY_UP) And vel<10 Then
			vel:+0.05
		ElseIf vel>0 Then
			vel:*0.98
		EndIf
		If KeyDown(KEY_SPACE) And MilliSecs()>shottimer+shotstime Then shoot
		x:+Cos(w)*vel
		y:+Sin(w)*vel
		If x>gw Then x:-gw
		If y>gh Then y:-gh
		If x<0 Then x:+gw
		If y<0 Then y:+gh
		
		If shieldticks>0 Then
			shieldticks:-1
			SetColor 0,200,255
			DrawOval x-18,y-18,36,36
			SetColor 0,0,0
			DrawOval x-17,y-17,34,34
		EndIf
		SetColor 100,100,255
		DrawLine x+Cos(w)*12,y+Sin(w)*12,x+Cos(w-135)*12,y+Sin(w-135)*12
		DrawLine x+Cos(w)*12,y+Sin(w)*12,x+Cos(w+135)*12,y+Sin(w+135)*12
		DrawLine x+Cos(w-135)*12,y+Sin(w-135)*12,x+Cos(w+135)*12,y+Sin(w+135)*12
	EndMethod
	Method invincible()
		Local d_end:Int=40
		inv_w:+1
		If TAsteroid.bonustime-MilliSecs()<=2000 Then d_end:-(2000-(TAsteroid.bonustime-MilliSecs()))/200
		SetColor 255,255,0
		For Local d:Int=30 To d_end Step 2
			For Local i:Int=inv_w To inv_w+360 Step 20
				Plot Cos(i+(d-30)*15)*d+x,Sin(i+(d-30)*15)*d+y
			Next
		Next
	EndMethod
EndType

Type TAsteroid
	Global list:TList=New TList
	Global bonustime:Int
	Field x:Float, y:Float, w:Int
	Field vel:Float, size:Int, life:Int
	Function _Create:TAsteroid(x:Float, y:Float, w:Int, vel:Float, size:Int)
		Local a:TAsteroid=New TAsteroid
		a.x=x; a.y=y; a.w=w; a.vel=vel; a.size=size ; a.life=size
		Return a
	EndFunction
	Function CreateRand(player_x:Int, player_y:Int)
		Local x:Float, y:Float,vel:Float
		Repeat
			x=Rand(0,gw-1)
		Until x>player_x+ASTEROID_STARTSIZE+15 Or x<player_x-ASTEROID_STARTSIZE-15
		Repeat
			y=Rand(0,gh-1)
		Until y>player_y+ASTEROID_STARTSIZE+15 Or y<player_y-ASTEROID_STARTSIZE-15
		If level<10 Then vel=Rnd(0,1) Else vel=Rnd(1,2)
		list.addlast _Create(x, y, Rand(0,359), Rnd(0,1), ASTEROID_STARTSIZE)
	EndFunction
	Function updateall()
		SetColor 255,160,0
		If bonustime Then player.invincible
		For Local a:TAsteroid=EachIn list
			a.update
		Next
	EndFunction
	Method hit(sw:Int)
		life:-ASTEROID_ENDSIZE
		If life<=0 Then split sw
	EndMethod
	Method split(sw:Int)
		If level>=3 And Rand(100)>=82 And Rand(100)<=18 Then TBonus.Create(x,y)
		player.score:+size
		TParticle.CreateSome size, x, y, Rnd(5,10), Rnd(0.9,0.98), 2, 50, $FF8000
		If size<ASTEROID_ENDSIZE Then list.remove Self; Return
		size:/2
		life=size
		vel:*1.4
		w=sw+30
		list.addlast _Create(x, y, sw-30, vel, size)
	EndMethod
	Method update()
		x:+Cos(w)*vel
		y:+Sin(w)*vel
		If x>gw Then x:-gw
		If y>gh Then y:-gh
		If x<0 Then x:+gw
		If y<0 Then y:+gh
		
		If MilliSecs()>bonustime Then bonustime=0
		
		If bonustime=0 And (x-player.x)*(x-player.x)+(y-player.y)*(y-player.y)<=size*size+100 Then
			If player.shieldticks=0 Then
				player.life:-size
				TParticle.CreateSome 10,player.x,player.y,6,0.97,2,20,$5050FF
				hit 360-player.w
			Else
				player.shieldticks:-size
				list.remove Self
				Return
			EndIf
		EndIf
				
		SetColor 255,160,0
		DrawOval x-size-1,y-size-1,2*size+2,2*size+2
		SetColor 0,0,0
		DrawOval x-size,y-size,2*size,2*size
		If size>ASTEROID_ENDSIZE Then
			SetColor 255,0,0
			DrawRect x-10,y-size-6,20,3
			SetColor 0,255,0
			DrawRect x-10,y-size-6,20.0*Float(life)/size,3
		EndIf
	EndMethod
EndType

Type TShot
	Global list:TList=New TList
	Field x:Float, y:Float, w:Int, ticks:Int
	Function Create(x:Float, y:Float, w:Int)
		Local s:TShot=New TShot
		s.x=x ; s.y=y ; s.w=w
		s.ticks=SHOT_STARTTICKS
		list.addlast s
	EndFunction
	Function updateall()
		For Local s:TShot=EachIn list
			s.update
		Next
		SetAlpha 1
	EndFunction
	Method update()
		x:+Cos(w)*10
		y:+Sin(w)*10
		For Local a:TAsteroid=EachIn TAsteroid.list
			If (a.x-x)*(a.x-x)+(a.y-y)*(a.y-y)<=a.size*a.size Then
				a.hit w
				list.remove Self
				Return
			EndIf
		Next
		If x>gw Then x:-gw
		If y>gh Then y:-gh
		If x<0 Then x:+gw
		If y<0 Then y:+gh
		If ticks<=30 Then SetAlpha Float(2*ticks)/SHOT_STARTTICKS Else SetAlpha 1
		SetColor 255,0,0
		DrawRect x-2,y-2,4,4
		ticks:-1
		If ticks=0 Then list.remove Self
	EndMethod
EndType


Type TParticle
	Global list:TList=New TList
	Field x:Float, y:Float, vel:Float, velp:Float, w:Int
	Field startticks:Int, ticks:Int, color:Int, size:Int
	Function Create(x:Int, y:Int, vel:Float, velp:Float, w:Int, size:Int, ticks:Int, color:Int)
		Local p:TParticle=New TParticle
		p.x=x; p.y=y; p.vel=vel; p.velp=velp; p.w=w; p.ticks=ticks
		p.startticks=ticks; p.color=color; p.size=size
		list.addlast p
	EndFunction
	Function CreateSome(i:Int, x:Int, y:Int, vel:Float, velp:Float, size:Int, ticks:Int, color:Int)
		For i=i To 1 Step -1
			Create x, y, vel, velp, Rand(0,359), size, ticks, color
		Next
	EndFunction
	Function updateall()
		For Local p:TParticle=EachIn list
			p.update
		Next
		SetAlpha 1
	EndFunction
	Method update()
		ticks:-1
		x:+Cos(w)*vel
		y:+Sin(w)*vel
		vel:*velp
		SetAlpha Float(ticks)/startticks
		SetColor color Shr 16, (color Shr 8) & $FF, color & $FF
		DrawRect x-size, y-size, 2*size, 2*size
		If ticks=0 Then list.remove Self
	EndMethod
EndType

Type TBonus
	Global list:TList=New TList
	Global colors:Int[]=[$00FFFF,$00FF00,$FFFFFF,$FF2000]
	Field x:Int,y:Int,time:Int, typ:Int
	Function Create(x:Int,y:Int)
		Local b:TBonus=New TBonus
		b.x=x ; b.y=y
		b.typ=Rand(1,4)
		b.time=MilliSecs()+Rand(3000,6000)
		list.addlast b
	EndFunction
	Function updateall()
		If list.isempty() Then Return
		Local b:TBonus
		SetColor 255,255,255
		For b=EachIn list
			b.update
		Next
	EndFunction
	Method update()
		If MilliSecs()>time Then list.remove Self;Return
		SetColor colors[typ-1] Shr 16,(colors[typ-1] Shr 8) & $FF,colors[typ-1] & $FF
		DrawRect x-10,y-10,20,20
		SetColor 0,0,0
		DrawRect x-9,y-9,18,18
		SetColor colors[typ-1] Shr 16,(colors[typ-1] Shr 8) & $FF,colors[typ-1] & $FF		
		DrawRect x-1,y-6,2,12
		DrawRect x-6,y-1,12,2
		If player.x>=x-15 And player.y>=y-15 And player.x<=x+15 And player.y<=y+15 Then
			Select typ
			Case 1
				player.shieldticks:+MAXSHIELD/3
				If player.shieldticks>MAXSHIELD Then player.shieldticks=MAXSHIELD
			Case 2
				player.life:+STARTLIFE/5
			Case 3
				If TAsteroid.bonustime=0 Then TAsteroid.bonustime=MilliSecs()
				TAsteroid.bonustime:+3000*level
				lastbonus=level
			Case 4
				If player.shots=4 Then
					If player.shotstime>70 Then player.shotstime:*0.85
				Else
					player.shots:+1
				EndIf
			EndSelect
			list.remove Self
		EndIf

	EndMethod
EndType

Function DrawButton:Int(id:Int,s:String,x:Int,y:Int,selection:Int,key:Int)
	Local w:Int,h:Int
	w=TextWidth(s)+20
	h=TextHeight(s)+10
	SetColor 100,100,255
	If selection=id Then SetColor 200,100,255
	DrawRect x-1,y-1,w+2,h+2
	SetColor 0,0,0
	DrawRect x,y,w,h
	SetColor 255,255,255
	DrawText s,x+10,y+5
	If key Then
		If selection=id Return id
	EndIf
	Return 0
EndFunction

Const MENU_START_GAME:Int=1, MENU_END_GAME:Int=2
Function menu(ingame:Int)
	Local selection:Int=1,press:Int,key:Int
	Delay 10
	FlushKeys
	Repeat
		Cls
		press=0
		If player And player.score Then
			If ingame Then
				DrawText "Bisherige Punktzahl: "+player.score,5,5
			Else
				DrawText "Letzte Punktzahl: "+player.score,5,5
			EndIf
		EndIf
		DrawText "ASTEROIDS",10,gh-45
		key=KeyHit(KEY_SPACE)
		If ingame Then
			press:+DrawButton(MENU_START_GAME,"Spiel fortsetzen",120,gh-50,selection,key)
		Else
			press:+DrawButton(MENU_START_GAME,"Neues Spiel",120,gh-50,selection,key)
		EndIf
		press:+DrawButton(MENU_END_GAME,"Ende",310,gh-50,selection,key)
		If KeyHit(KEY_LEFT) And selection>MENU_START_GAME Then selection:-1
		If KeyHit(KEY_RIGHT) And selection<MENU_END_GAME Then selection:+1
		Select press
		Case MENU_START_GAME
			Delay 10
			FlushKeys
			If Not ingame Then
				player=New TPlayer
				TAsteroid.list.clear()
				TBonus.list.clear()
				TShot.list.clear()
				TParticle.list.clear()
				level=0
				lastbonus=0
				Main
			Else
				Exit
			EndIf
		Case MENU_END_GAME
			End
		EndSelect
		If AppTerminate() Then End
		Flip 0
		WaitTimer timer
	Until KeyHit(KEY_ESCAPE)
EndFunction